// Dist demo Distance

float x1, y1, diam1, dx1, dy1, x2, y2, diam2, dx2, dy2;

void setup( )
{
  size( 400, 800 );
  noStroke( );
  
  x1 = random( width );
  y1 = random( height );
  diam1 = random( 50, 100 );
  dx1 = 2;
  dy1 = 3;
  
  x2 = random( width );
  y2 = random( height );
  diam2 = random( 50, 100 );
  dx2 = 4;
  dy2 = 2; 
}

void draw( )
{
  prepareWindow( );
  moveFigs( );
  drawFigs( );
  checkCollision( );

}

void moveFigs( )
{
  // wrapping figure
  x1 += dx1;
  if ( x1 > width  ) x1 = 0;
  if ( x1 < 0 ) x1 = width ;
  y1 += dy1;
  if ( y1 > height ) y1 = 0;
  if ( y1 < 0 ) y1 = height;
  
  // bouncing figure
  x2 += dx2;
  if ( x2 > width  || x2 < 0 ) dx2 = -dx2;
  y2 += dy2;
  if ( y2 > height || y2 < 0 ) dy2 = -dy2;
}

void drawFigs( )
{
  fill( 255, 0, 0 );
  ellipse( x1, y1, diam1, diam1 );
  
  fill( 0, 255, 0 );
  ellipse( x2, y2, diam2, diam2 );
}

void checkCollision( )
{
  float actualDistance = dist( x1, y1, x2, y2 );
  float collisionDistance = diam1/2 + diam2/2;
  if ( actualDistance < collisionDistance )
  {
    fill( 255, 0, 0 );
    rect( 0, 0, width, height );
    dx1 = -dx1;
    dy1 = -dy1;
    dx2 = -dx2;
    dy2 = -dy2;
  }
}


void prepareWindow( )
{
   fill( 0, 50 );
   rect( 0, 0, width, height );
  
}
