// slider demo

float barX, barY, barWidth, barHeight;
float sliderWidth, sliderX;

int bgCol;

void setup( )
{
  size( 400, 400 );
  rectMode( CENTER );
  textAlign( CENTER );
  textSize( 18 );
  barX = width/2;
  barY = height*.8;
  barWidth = width*.8;
  barHeight = height*.15;
  sliderX = width/2;
  sliderWidth = 5;
  
  bgCol =  127 ;
}

void draw( )
{
  background( color( bgCol ) );
  showSlider( );
}

void showSlider( )
{
  fill( 255, 0, 0 );
  rect( barX, barY, barWidth, barHeight );
  fill( 0, 200, 0 );
  rect( sliderX, barY, sliderWidth, barHeight );  
  fill( 0 );
  text("Bar Location: " + int(sliderX), barX, barY-5 );
  text("Color Value:  " + bgCol, barX, barY+15 );
}

void mouseDragged( )
{
  if ( mouseX >= barX-barWidth/2  && mouseX <= barX+barWidth/2 &&
       mouseY >= barY-barHeight/2 && mouseY <= barY+barHeight/2 )
      {
        bgCol = int( map(mouseX, barX-barWidth/2, barX+barWidth/2, 0, 255 ) );
        sliderX = mouseX;
      } 
}
